// compile:   g++ -Wall    OperatorOverloading-CPP.cpp -o OperatorOverloading-CPP
// gimple:    g++ -Wall    OperatorOverloading-CPP.cpp -o OperatorOverloading-CPP -fdump-tree-gimple 
// assembler: g++ -Wall -S OperatorOverloading-CPP.cpp -o OperatorOverloading-CPP.s

// Questions
//  -Is there any runtime cost associated with this example?
//  -What is the return value optimization and how and when does it help?
//  -Why use "friend" functions in connection with binary operator overloading?
//  -What broken bit of C++ makes it important to use "++i" over "i++"?
//  -What is the difference between "&" and "*" and why use "&"?
//  -How would you make Object work with cout (i.e., the ostream class)?

#include <iostream>

struct Object {
  float x;

  Object(float x) { this->x = x; }
  ~Object()       { }

  const Object &operator=(const Object &y) { x = y.x; return *this; }

  friend const Object operator*(const Object &x,const Object &y) { return Object(x.x*y.x); }
  friend const Object operator+(const Object &x,const Object &y) { return Object(x.x+y.x); }

  void print() const { std::cout << x << std::endl; }
};

int main() {
  Object x(2.1);
  Object y(4.2);
  Object z(5.1);

  (x+y+z).print();

  return 0;
}
